package com.persagy.bdtp.adm.entity;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.common.helper.SpringHelper;
import com.persagy.dmp.digital.entity.ObjectDigital;
import lombok.Data;

import java.io.IOException;

@Data
@TableName(value = "adm_object",autoResultMap = true)
public class AdmObject extends ObjectDigital implements IAdmBdtpEntity {

	/** 创建对象的本地设备(移动端) */
	private String clientDevice;

	/** 由本地设备生成的对象id */
	private String clientId;

	/**  数模同步状态：0未同步, 1已同步 */
	private Integer d2mState;

	/** 交付BDTP状态:1已交付,0待交付 */
	private Integer deliveryState;

	private String buildingId;

	private String floorId;

	/** app端上传数据标记 */
	private String uploadFlag;

	private String strInfos;

	public JsonNode getInfo(String infoCode){
		ObjectNode node = getInfos();
		if(node != null)
			return node.get(infoCode);
		return null;
	}

	@Override
	public void serializeJsonProp() {
		if(getInfos() != null) {
			ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
			try {
				setStrInfos(objectMapper.writeValueAsString(getInfos()));
			} catch (JsonProcessingException e) {

			}
			setInfos(null);
		}
	}

	@Override
	public void deserializeJsonProp() {
		if(StrUtil.isNotBlank(strInfos)) {
			ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
			try {
				setInfos(objectMapper.readValue(strInfos, ObjectNode.class));
			} catch (IOException e) {

			}
			setStrInfos(null);
		}
	}

}
