package com.persagy.bdtp.adm.entity;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.common.helper.SpringHelper;
import lombok.Data;

import java.io.IOException;
import java.util.List;

@Data
@TableName(value = "adm_pipe",autoResultMap = true)
public class AdmPipe extends BaseAdmDataEntity {

    private String objFrom;

    private String typeFrom;

    private String objTo;

    private String typeTo;

    private Integer direction;

    private String pipeType;

    private String pipeSubType;

    @TableField(
            typeHandler = JacksonTypeHandler.class
    )
    private List<Object> route;

    @TableField(
            typeHandler = JacksonTypeHandler.class
    )
    private ObjectNode infos;

    /**  数模同步状态：0未同步, 1已同步 */
    private Integer d2mState;

    /** 交付BDTP状态:1已交付,0待交付 */
    private Integer deliveryState;

    private String strRoute;

    private String strInfos;

    @Override
    public void serializeJsonProp() {
        if(route != null) {
            ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
            try {
                strRoute = objectMapper.writeValueAsString(route);
            } catch (JsonProcessingException e) {

            }
            route = null;
        }
        if(infos != null) {
            ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
            try {
                setStrInfos(objectMapper.writeValueAsString(infos));
            } catch (JsonProcessingException e) {

            }
            setInfos(null);
        }
    }

    @Override
    public void deserializeJsonProp() {
        if(StrUtil.isNotBlank(strRoute)) {
            ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
            try {
                route = objectMapper.readValue(strRoute, List.class);
            } catch (IOException e) {

            }
            strRoute = null;
        }
        if(StrUtil.isNotBlank(strInfos)) {
            ObjectMapper objectMapper = SpringHelper.getBean(ObjectMapper.class);
            try {
                setInfos(objectMapper.readValue(strInfos, ObjectNode.class));
            } catch (IOException e) {

            }
            setStrInfos(null);
        }
    }

}